# Copyright (c) 2004, James Seng. (http://james.seng.cc/)
# This code is released under the Artistic License.

package MT::App::Redirect;
use strict;

use MT::App;
@MT::App::Redirect::ISA = qw( MT::App );

sub init {
    my $app = shift;
    $app->SUPER::init(@_) or return;
    $app->add_methods(
            'ping'      => \&redirect_ping,
            'comment'   => \&redirect_comment,
            'error'     => \&redirect_home,
    );
    $app->{default_mode} = 'error';
    $app;
}

sub _redirect {
    my ($url) = shift;

    print <<__REDIRECT__;
URI: $url
Location: $url
Connection: close
Content-Type: text/html; charset=iso-8859-1

<body>
You are not suppose to see this if your browser handle automatic redirection. If so, please click <a href="$url">here</a>.
</body>
__REDIRECT__
}

sub redirect_comment {
    my $app = shift;
    my $q = $app->{query};
    my $comment_id = $q->param('id');

    print "$comment_id";
    require MT::Comment;
    my $comment = MT::Comment->load($comment_id);
    my $url = $comment->url;

    _redirect($url);
}

sub redirect_ping {
    my $app = shift;
    my $q = $app->{query};
    my $ping_id = $q->param('id');

    require MT::TBPing;
    my $ping = MT::TBPing->load($ping_id);

    _redirect($ping->source_url());
}

sub redirect_home {
    _redirect("/");
}

1;
