# Copyright (c) 2003, James Seng. (http://james.seng.cc/)
# This code is released under the Artistic License.

use MT::Template::Context;
require MT::Bayesian;

use MT::Util qw( start_end_day start_end_week start_end_month
                 munge_comment archive_file_for
                 format_ts offset_time_list first_n_words dirify get_entry
                 encode_html encode_js remove_html wday_from_ts days_in
                 spam_protect encode_php encode_url decode_html encode_xml
                 decode_xml );

# Configure this one #
$redirect = "mt-redirect.cgi";

MT::Template::Context->add_tag(CommentAuthorLink => 
    \&_redirect_comment_author_link);

MT::Template::Context->add_tag(PingURL => 
    \&_redirect_ping_url);

sub _redirect_comment_author_link {
    #sanitize_on($_[1]);
    $_[0]->{'sanitize'} = 1 unless exists $_[0]->{'sanitize'};
    my($ctx, $args) = @_;
    my $tag = $ctx->stash('tag');
    my $c = $ctx->stash($tag =~ /Preview/ ? 'comment_preview' : 'comment')
        or return $ctx->_no_comment_error('MT' . $tag);
    my $name = $c->author;
    $name = '' unless defined $name;
    my $show_email = 1 unless exists $args->{show_email};
    my $show_url = 1 unless exists $args->{show_url};
    if ($show_url && $c->url) {
        my $url = $redirect;
        if ($redirect !~ /^http/) {
            my $cgipath = MT::ConfigMgr->instance->CGIPath;
            $cgipath .= '/' unless $cgipath =~ m!/$!;
            $url = $cgipath . $redirect;
        }
        return sprintf 
            qq(<a target="_blank" href="%s?__mode=comment&id=%s">%s</a>), 
                $url, $c->id, $name;
    } elsif ($show_email && $c->email) {
        my $email = remove_html($c->email);
        my $str = "mailto:" . $email;
        $str = spam_protect($str) if $args->{'spam_protect'};
        return sprintf qq(<a href="%s">%s</a>), $str, $name;
    } else {
        return $name;
    }
}

sub _redirect_ping_url {
    #sanitize_on($_[1]);
    $_[0]->{'sanitize'} = 1 unless exists $_[0]->{'sanitize'};
    my $ping = $_[0]->stash('ping')
        or return $_[0]->_no_ping_error('MTPingURL');

    my $url = $redirect;
    if ($redirect !~ /^http/) {
        my $cgipath = MT::ConfigMgr->instance->CGIPath;
        $cgipath .= '/' unless $cgipath =~ m!/$!;
        $url = $cgipath . $redirect;
    }
    my $purl = sprintf("%s?__mode=ping&id=%s", $url, $ping->id);
    
    defined $ping->source_url ? $purl : '';
}

1;
